
#import "ICCrawler.h"
#import "TFHpple.h"
#import "TFHppleElement.h"

@implementation ICCrawler
@synthesize data,html,container;

-(id)initWithURL:(NSString *)url {
	NSError *theError;
	if (self=[super init])
	{
		data=[NSData dataWithContentsOfURL:[NSURL URLWithString:url] options:1 error: &theError];								  
		
		if(data == nil) {
			NSLog(@"Html content Loading Was Not Established! \n The Error is: %@", [theError localizedDescription]);
			
		} else {
		
		html=[[TFHpple alloc] initWithHTMLData:data];
		container=[NSMutableArray array];
		}
	}
	return self;
}	

-(id)initWithFile:(NSString *)url {
	
	NSError *theError;
	if (self=[super init])
	{
		data=[NSData dataWithContentsOfFile:url options:1 error:&theError];
								   		
		if(data == nil) {
			NSLog(@"Html content Loading Was Not Established! \n The Error is: %@", [theError localizedDescription]);
			
		} else {
			
			html=[[TFHpple alloc] initWithHTMLData:data];
			container=[NSMutableArray array];
		}
	}
	return self;
}	

-(void)dealloc{
	
	[html release];
	[super dealloc];
}

-(NSString *)webPageTitle{
	
	NSArray *elements=[html searchWithXPathQuery:@"//title/text()"];
	TFHppleElement *e=[elements objectAtIndex:0];
	return [e content];
	
}
-(NSString *)keywords{
	
	NSArray *elements=[html searchWithXPathQuery:@"/html/head/meta[@name=\"keywords\"]/@content"];
	for(TFHppleElement *e in elements){
		[container addObject: [e content]];
	}
	return container;
	
}

-(NSString *)description{

	NSArray *elements=[html searchWithXPathQuery:@"/html/head/meta[@name=\"description\"]/@content"];
	for(TFHppleElement *e in elements){
		[container addObject: [e content]];
	}
	return container;

}


-(NSMutableArray *)headings{
	
	NSArray *elements=[html searchWithXPathQuery:@"//*[name()='h1' or name()='h2']"];
	
	for(TFHppleElement *e in elements){
		if ([e content]!= NULL && [[e content] isNotEqualTo:@""] ) {
			
			[container addObject: [e content]];
		}
	}
	
	return container;
	
	
}
-(NSMutableArray *)textLinks{
	
	NSArray *elements=[html searchWithXPathQuery:@"//a"];
	
	for(TFHppleElement *e in elements){
		if ([e content]!= NULL && [[e content] isNotEqualTo:@""] ) {
			
			[container addObject: [e content]];
		}
	}
	
	return container;
	

}
-(NSMutableArray *)paragraphes{
	
	
	NSArray *elements=[html searchWithXPathQuery:@"//p"];
	
	for(TFHppleElement *e in elements){
		if ([e content]!= NULL && [[e content] isNotEqualTo:@""] ) {
	
			[container addObject: [e content]];
		}
	}

	return container;
	
	
}

-(NSMutableArray *)imageAlt{

	NSArray *elements=[html searchWithXPathQuery:@"//img"];
	
	for(TFHppleElement *e in elements){
		if ([e objectForKey:@"alt"]!= NULL && [[e objectForKey:@"alt"] isNotEqualTo:@""] ) {
			
			[container addObject: [e objectForKey:@"alt"]];
		}
	}
	return container;
}

@end
