#import "ICLinkExtractor.h"
#import "ICScheduler.h"
#import "TFHpple.h"
#import "TFHppleElement.h"

@implementation ICLinkExtractor


-(NSMutableArray*)extract:(NSString*)url{
	
	NSMutableArray *pageURLs=[NSMutableArray array];
	
	NSData *data=[NSData dataWithContentsOfURL:[NSURL URLWithString:url]];
	
	TFHpple *html=[[[TFHpple alloc] initWithHTMLData:data] autorelease];
	
	NSArray *links=[html searchWithXPathQuery:@"//a"];
	
	
	if ([links count]==0){
		NSLog(@"%@ does not contain any link!",url);
		return nil;
	}

	for (TFHppleElement *l in links)
		[pageURLs addObject:[l objectForKey:@"href"]];
	
	
	return pageURLs;

}

@end


////////////////////////Link Extractor class which consider policies////////////////////////
// this class inherit the ICLinkExtractor

@implementation ICLinkExtractorWithPolicies
@synthesize disallow;

/// should be revised after i add current site to the scheduler

-(void)checkRobots{
	disallow=[NSMutableArray array];
	NSError *theError;
	
	ICScheduler *scheduler=[[[ICScheduler alloc] init] autorelease];	
	NSMutableString *robotsURL;
	[robotsURL appendFormat:@"%@%@%@",[scheduler currentWebsite],@"/",@"robots.txt"];
	
	NSURL *url=[NSURL URLWithString:(NSString *)robotsURL];
		
	NSString *content = [NSString stringWithContentsOfURL:url encoding:NSUTF8StringEncoding error:&theError];
		
	if(content == nil) {
		NSLog(@"Robots' content Loading Was Not Established! \n The Error is: %@", [theError localizedDescription]);
			
	} else {
			
		NSArray *parsed = [content componentsSeparatedByCharactersInSet:[NSCharacterSet newlineCharacterSet]];
			
		for(NSMutableString *line in parsed) {
			if ([line hasPrefix:@"Disallow"]) {
				[disallow addObject:[line substringFromIndex:9]];
			}
		}
			
	}
			
}




-(BOOL)checkRevisitPolicy: (NSString*)url{
	
	ICScheduler *sch=[[[ICScheduler alloc]init] autorelease];
	NSArray *tempArray= [sch returnWebpageQueue];
	if([tempArray containsObject:url]== YES){
		return YES;
	}else
		return NO;
}


-(NSMutableArray *) extractWithPolicies: (NSString*)url{
	
	NSMutableArray *pageURLs=[NSMutableArray array];
	NSURL *tempUrlObject;
	NSString *stringLink;
	NSArray *links=[self extract:url]; //return all the links from the page. 
	ICScheduler *scheduler=[[[ICScheduler alloc] init] autorelease];
	if ([links count]==0){
		NSLog(@"%@ does not contain any new URL!");
		//return nil;
	}
	for(NSString *l in links){
		
		// Step (1) check baned URLs.
		
		if ([disallow containsObject:l]== YES) {
			continue;
		}
		
		// Step (2) check if URL has host name.
		tempUrlObject=[NSURL URLWithString:l];
		if ([tempUrlObject host]== NULL) {
			NSMutableString *str=[NSMutableString stringWithFormat:@"%@%@",[scheduler currentWebsite],url];
			stringLink = (NSString *)str;
		}
		
		// Step (3)check revisit policy
		
		if ([self checkRevisitPolicy:stringLink]== NO) {
			[pageURLs addObject:stringLink];
		}
		
		
	}
	
	
	return pageURLs;
}

@end
