
#import "ICScheduler.h"


@implementation ICScheduler

@synthesize webSiteQueue,webPageQueue;

-(id)init{

	if (self=[super init])
	{
		webSiteQueue = [[NSMutableArray alloc] initWithCapacity:1];
		webPageQueue = [[NSMutableArray alloc] initWithCapacity:1];
		linkCounter=0;
		siteCounter=0;
		
	}
	return self;
}

-(void)dealloc{
	
	[webPageQueue release];
	[webSiteQueue release];
	[super dealloc];
}
-(void) addWebsiteURL: (NSString *) url{
	
	[webSiteQueue addObject:url];
	NSLog(@"%@ is added!",url);
}
-(void) addURL: (NSString *) link{
	
	[webPageQueue addObject:link];
	NSLog(@"%@ link is added!",link);
}
-(void) addURLs: (NSArray *) links{
	
	[webPageQueue addObjectsFromArray:links];
}

//add webpages' URLs that are downloaded in a certain folder.
-(NSMutableArray*) returnURLsFromPath: (NSString *)path{
	
	NSFileManager *filemgr;
	NSArray *fileNames;
	NSMutableArray *fileURLs=[[[NSMutableArray alloc]init] autorelease];
	filemgr = [NSFileManager defaultManager];
	fileNames = [filemgr directoryContentsAtPath: path];
	
	if ([filemgr fileExistsAtPath:path]==NO) {
	
		NSLog(@"This path does not exist or its existence could not be determined!");

	}else {

		for(int i=0; i <[fileNames count]; i++)
		{
			[fileURLs addObject:[path stringByAppendingFormat:[fileNames objectAtIndex:i]]];
			//NSLog (@"%@", [fileURLs objectAtIndex: i]);
		}
	}	
	
	return fileURLs;
}

-(void) addURLsFromPath: (NSString *)path{
	
	NSFileManager *filemgr;
	NSArray *fileNames;
	NSMutableArray *fileURLs=[[NSMutableArray alloc]init];
	filemgr = [NSFileManager defaultManager];
	fileNames = [filemgr directoryContentsAtPath: path];
	
	if ([filemgr fileExistsAtPath:path]==NO) {
		
		NSLog(@"This path does not exist or its existence could not be determined!");
		
	}else {
		
		for(int i=0; i <[fileNames count]; i++)
		{
			[fileURLs addObject:[path stringByAppendingFormat:[fileNames objectAtIndex:i]]];
			//NSLog (@"%@", [fileURLs objectAtIndex: i]);
		}
	}	
	[webPageQueue addObjectsFromArray:fileURLs];
	[fileURLs autorelease];	
}


// preferly PLIST file // add path existance !!!
-(NSArray*) returnURLsFromFile: (NSString *)path{
	
	NSArray *urls=[NSArray arrayWithContentsOfFile:path];
	return urls;
}



-(void) addURLsFromFile: (NSString *)path{

	NSArray *urls=[NSArray arrayWithContentsOfFile:path];
	[webPageQueue addObjectsFromArray:urls ];

}



-(NSMutableArray *)returnWebpageQueue{
	NSLog(@"returnWebpageQueue is :%@",webPageQueue);
	return webPageQueue;
	
}

-(NSString*) currentWebsite{
	return [webSiteQueue objectAtIndex:siteCounter];

}

-(id) nextRequest{
	
	
	if ([webSiteQueue count]==0) {
		NSLog(@"There is no website URL to Crawl!");
		return nil;
	}
	// When WebPage Queue is empty.
	if ([webPageQueue count]==0) {
		NSLog(@"Webpage Queue is empty!");
		return nil;
	}
	// When all URLs are crawled
	if([webPageQueue count] == (linkCounter+1)){
		
		NSLog(@"%@'s links are Crawled!",[webSiteQueue objectAtIndex:siteCounter]);
		if (([webSiteQueue count] == (siteCounter+1))) {
			NSLog(@"There is no more Website to crawl! Crawling has ended.");
			return nil;
		}else {
			
			siteCounter++;
			linkCounter=0;
			//LinkExtractor([websiteQueue objectAtIndex:siteCounter]);
			[self nextRequest];
		}
	}
	
	return [webPageQueue objectAtIndex:linkCounter++];
	
}

@end
